$regfile = "m8def.dat"
$crystal = 8000000
$baud = 9600

Config Pind.2 = Input
Config Portc.0 = Output
Config Portc.1 = Output
Config Portc.2 = Output
Config Portc.3 = Output
Config Portc.4 = Output
Config Portc.5 = Output
Config Portd.7 = Output
Config Portd.6 = Output



Config Timer0 = Timer , Prescale = 256                      '8000000/256=31250 Hz
Config Int0 = Falling                                       'Interruption on Falling
Stop Timer0
Enable Timer0
Enable Int0
Enable Interrupts
On Timer0 Tikers                                            'work on timer
On Int0 Infrared                                            'work on interruption

Dim Tik As Word                                             'counter of teaks of timer
Dim Byt As Byte                                             'counter accepted bit
Dim Repeat_flag As Bit                                      'flag of repetition
Dim Start_flag As Bit                                       'flag of start condition
Dim Address As Byte                                         'byte of address
Dim Command As Byte                                         'byte of command
Dim Address_1 As Byte                                       'direct byte of address
Dim Command_1 As Byte                                       'direct byte of command
Dim Address_0 As Byte                                       'indirect byte of address
Dim Command_0 As Byte                                       'indirect byte of command
Dim Summa As Word
Dim Ausgabe As Byte


'################################################################################################################

Do                                                          'Main cycle

Print Address ; " " ; Command                               'Lcd ADDRESS and COMMAND
Portc.0 = 0
Portc.1 = 0
Portc.2 = 0
Portc.3 = 0
Portc.4 = 0
Portc.5 = 0
Portd.7 = 0
Portd.6 = 0

If Command = 58 Then
Portc.0 = 1
Waitms 10
End If

If Command = 186 Then
Portc.1 = 1
Waitms 10
End If

If Command = 2 Then
Portc.2 = 1
Waitms 10
End If

If Command = 26 Then
Portc.3 = 1
Waitms 10
End If

If Command = 154 Then
Portc.4 = 1
Waitms 10
End If

If Command = 162 Then
Portc.5 = 1
Waitms 10
End If

If Command = 34 Then
Portd.7 = 1
Waitms 10
End If

If Command = 232 Then
Portd.6 = 1
Waitms 10
End If

If Command = 200 Then
Portc.0 = 1
Waitms 500
End If

If Command = 24 Then
Portc.1 = 1
Waitms 500
End If

If Command = 10 Then
Portc.2 = 1
Waitms 500
End If

If Command = 88 Then
Portc.3 = 1
Waitms 500
End If

If Command = 32 Then
Portc.4 = 1
Waitms 500
End If

If Command = 160 Then
Portc.5 = 1
Waitms 500
End If

If Command = 96 Then
Portd.7 = 1
Waitms 500
End If

If Command = 224 Then
Portd.6 = 1
Waitms 500
End If




Waitms 10                                                   'Delay 10 ??
Loop
End                                                         'End of main cycle

'################################################################################################################

 Tikers:                                                    'work on timer
 Timer0 = 253                                               '31250/(256-253)=10416,66 Hz (96 ???)
 Incr Tik
 If Tik >= 1200 Then                                        'if 1200 teaks, have thrown all in source condition
 Tik = 0
 Repeat_flag = 0
 Start_flag = 0
 Address_1 = 0
 Command_1 = 0
 Address_0 = 0
 Command_0 = 0
 Address = 0
 Command = 0
 Stop Timer0
 End If
 Return
'################################################################################################################

 Infrared:                                                  'work on interruption
 Start Timer0

 If Tik >= 139 And Tik < 150 Then                           'if has happenned from 139 before 150 teaks - "START"
  Address = 1
  Repeat_flag = 0
  Start_flag = 1
  Address_1 = 0
  Command_1 = 0
  Address_0 = 0
  Command_0 = 0
 End If

 If Tik >= 116 And Tik < 139 Then                           'if has happenned from 116 before 138 teaks - "REPETITION"
  Address = 2
  Repeat_flag = 1
  Start_flag = 0
 End If

 If Tik >= 22 And Tik < 116 And Start_flag = 1 Then         'if has happenned from 22 before 115 teaks - have taken "1"
 Incr Byt

 If Byt < 9 Then
 Shift Address_1 , Left
     Address_1 = Address_1 + 1
 End If

 If Byt >= 9 And Byt < 17 Then
 Shift Address_0 , Left
     Address_0 = Address_0 + 1
 End If

 If Byt >= 17 And Byt < 25 Then
 Shift Command_1 , Left
     Command_1 = Command_1 + 1
 End If

 If Byt >= 25 Then
 Shift Command_0 , Left
     Command_0 = Command_0 + 1
 End If
 End If

 If Tik >= 10 And Tik < 22 And Start_flag = 1 Then          'if has happenned from 10 before 21 teaks - have taken "0"
 Incr Byt

 If Byt < 9 Then
 Shift Address_1 , Left
 End If

 If Byt >= 9 And Byt < 17 Then
 Shift Address_0 , Left
 End If

 If Byt >= 17 And Byt < 25 Then
 Shift Command_1 , Left
 End If

 If Byt >= 25 Then
 Shift Command_0 , Left
 End If
 End If

 Tik = 0

 If Byt = 32 Then                                           'if have taken 4 bytes, check correctness a receiving a command

    Address = Address_1

    Command = Command_1

  Byt = 0
  Repeat_flag = 0
  Start_flag = 0
 Stop Timer0
 End If

 Return